#!/bin/bash

set -xuve
date

case $model in
 EC-EARTH-v2)
  nemo_i=4
  nemo_j=4
  cd $deploy_dir/sources/build
  ./compilation.ksh -i $nemo_i -j $nemo_j
  cp -pf $deploy_dir/sources/oasis3/prism_2-5/prism/*/bin/oasis3.MPI1.x $deploy_dir/bin
  cp -pf $deploy_dir/sources/nemo/nemo_build/opa_exe.ORCA1_OASIS3.$nemo_i.$nemo_j $deploy_dir/bin
  cp -pf $deploy_dir/sources/ifs/bin/ifsMASTER $deploy_dir/bin
  cp -pf $deploy_dir/sources/build/setup* $deploy_dir/setup
  cp -pf $deploy_dir/sources/build/run* $deploy_dir/scripts
 ;;
 EC-EARTH-v3.0)
  arch=eexcon
  nemo_i=4
  nemo_j=4
  cd $deploy_dir/sources/build-config
  ./compilation.sh -i $nemo_i -j $nemo_j
  cp -pf $deploy_dir/sources/oasis3/$arch/bin/oasis3.MPI1.x $deploy_dir/bin
  cp -pf $deploy_dir/sources/nemo3/bin/opa-${arch}-${nemo_i}x${nemo_j} $deploy_dir/bin
  cp -pf $deploy_dir/sources/ifs-*/bin/ifsmaster-${arch} $deploy_dir/bin
  cp -rpf $deploy_dir/sources/work/scripts/examples/ctrl $deploy_dir/setup
  cp -pf $deploy_dir/sources/build-config/run* $deploy_dir/scripts
 ;;
 EC-EARTH-v3.1)
  arch=eexcon
  cd $deploy_dir/sources/build-config
  ./compilation.sh
  cp -pf $deploy_dir/sources/oasis*/$arch/bin/oasis3.MPI1.x $deploy_dir/bin
  for nemo_config in `ls -1 $deploy_dir/sources/nemo*/CONFIG | grep ORCA`; do
   mkdir -p $deploy_dir/bin/$nemo_config
   cp -pf $deploy_dir/sources/nemo*/CONFIG/$nemo_config/BLD/bin/*.exe $deploy_dir/bin/$nemo_config
  done
  cp -pf $deploy_dir/sources/ifs*/bin/ifsmaster-${arch} $deploy_dir/bin
  cp -rpf $deploy_dir/sources/build-config/ctrl $deploy_dir/setup
  cp -pf $deploy_dir/sources/build-config/run* $deploy_dir/scripts
 ;;
 NEMO-EC-EARTH-v2)
  nemo_i=6
  nemo_j=6
  cd $deploy_dir/sources/build
  ./compilation.ksh -i $nemo_i -j $nemo_j
  cp -pf $deploy_dir/sources/nemo/nemo_build/opa_exe.ORCA1_OASIS3.$nemo_i.$nemo_j $deploy_dir/bin
  cp -pf $deploy_dir/sources/build/setup* $deploy_dir/setup
  cp -pf $deploy_dir/sources/build/run* $deploy_dir/scripts
  cd $deploy_dir/inidata/testdata
  rm -rf FOcean ifs oasis3 SlabOcean
 ;;
 NEMO-v3.2)
  nemo_i=6
  nemo_j=6
  cd $deploy_dir/sources/modipsl/config/ORCA2_LIM
  ./compilation.sh -i $nemo_i -j $nemo_j
  cp -pf $deploy_dir/sources/modipsl/bin/* $deploy_dir/bin
  cp -pf $deploy_dir/sources/modipsl/config/ORCA2_LIM/namelist* $deploy_dir/setup
  cp -pf $deploy_dir/sources/modipsl/config/ORCA2_LIM/run* $deploy_dir/scripts
 ;;
 NEMO-v3.3)
  nemo_i=6
  nemo_j=6
  cd $deploy_dir/sources/NEMOGCM/CONFIG
  ./compilation.sh -i $nemo_i -j $nemo_j
  cp -pf $deploy_dir/sources/NEMOGCM/CONFIG/ORCA2_LIM/BLD/bin/nemo.exe $deploy_dir/bin
  cp -pf $deploy_dir/sources/NEMOGCM/EXTERNAL/IOIPSL/tools/rebuild $deploy_dir/bin
  cp -pf $deploy_dir/sources/NEMOGCM/TOOLS/REBUILD/BLD/bin/flio_rbld.exe $deploy_dir/bin
  cp -pf $deploy_dir/sources/NEMOGCM/CONFIG/namelist* $deploy_dir/setup
  cp -pf $deploy_dir/sources/NEMOGCM/CONFIG/run* $deploy_dir/scripts
 ;;
 *)
 echo "$model is not available"
 ;;
esac
