#!/bin/bash
#
# nohup ./deploy.sh conf/*.conf >& log/*.log &
#
set -xuve
date
hostname
main=`pwd`

# General settings 
conf=$1
. ./$conf
mkdir -p $deploy_dir
export tmp_dir=$tmp_path/${model}_$$
rm -rf $tmp_dir
mkdir -p $tmp_dir

# Create directory structure
cd $deploy_dir
mkdir -p sources inidata scripts setup docs patches bin

# Inflate sources inidata scripts setup docs patches bin
# Inflate compilation patch & platform specific stuff
$main/inflate.sh

# Configure & Compile model and Perform post-compilation steps
$main/compile.sh

find $deploy_dir/. -type d | xargs chmod 775 2>/dev/null
find $deploy_dir/inidata -type f | xargs chmod 666 2>/dev/null
find $deploy_dir/scripts -type f | xargs chmod 666 2>/dev/null
find $deploy_dir/setup -type f | xargs chmod 666 2>/dev/null

rm -rf $tmp_dir

date
