#!/bin/bash

set -xuve
date

files=`find $source_dir/* -type f -maxdepth 0`
for file in $files; do
 cp -f $file $tmp_dir
done

files=`ls $tmp_dir`
for file in $files; do
 output=$(python -c "print '$file'.__contains__('src')") > /dev/null
 bfile=`echo $file | rev | cut -d '.' -f1 | rev`
 case $bfile in
  tar) tarf="tar -xvf"
  ;;
  gz|tgz) tarf="tar -zxvf"
  ;;
  *) echo "$bfile not a valid format";
  ;;
 esac
 if [ $output == 'True' ]; then
  $tarf $tmp_dir/$file -C $deploy_dir/sources
 fi
 output=$(python -c "print '$file'.__contains__('data')") > /dev/null
 if [ $output == 'True' ]; then
  $tarf $tmp_dir/$file -C $deploy_dir/inidata
 fi
 output=$(python -c "print '$file'.__contains__('scripts')") > /dev/null
 if [ $output == 'True' ]; then
  $tarf $tmp_dir/$file -C $deploy_dir/scripts
 fi
 output=$(python -c "print '$file'.__contains__('setup')") > /dev/null
 if [ $output == 'True' ]; then
  $tarf $tmp_dir/$file -C $deploy_dir/setup
 fi
 output=$(python -c "print '$file'.__contains__('docs')") > /dev/null
 if [ $output == 'True' ]; then
  $tarf $tmp_dir/$file -C $deploy_dir/docs
 fi
 output=$(python -c "print '$file'.__contains__('patches')") > /dev/null
 if [ $output == 'True' ]; then
  $tarf $tmp_dir/$file -C $deploy_dir/patches
 fi
 output=$(python -c "print '$file'.__contains__('bin')") > /dev/null
 if [ $output == 'True' ]; then
  $tarf $tmp_dir/$file -C $deploy_dir/bin
 fi
done
rm $tmp_dir/*

cp $patch_dir/$patch_file $tmp_dir
tar -zxvf $tmp_dir/$patch_file -C $deploy_dir/sources
rm $tmp_dir/*
