#!/bin/bash
#
# nohup ./dc.sh >& expid.log &
#
set -xuve
date

plt=ithaca
src=/share/data/cfu/exp

exp="i019"     # expid
sda="20051101"   # list of start dates yyyymmdd, yyyymmdd
mem="fc0"   # list of members fc0, fc1 etc
rem=FALSE # remove experiment output from source

dst1=/cfunas/exp/ecearth
#dst2=/cfunas/exp/ecearth/gribfiles

for s in $sda; do
 for m in $mem; do
  date
  mkdir -p $dst1/$exp/$s/$m/restarts
  mkdir -p $dst1/$exp/$s/$m/outputs
#  mkdir -p $dst2/$exp/$s/$m/outputs/
  set +e
  if [[ $rem == TRUE ]]; then
      rsync -acrv --remove-sent-files ${plt}:${src}/$exp/$s/$m/logfiles* $dst1/$exp/$s/$m/
     rsync -acrv --remove-sent-files ${plt}:${src}/$exp/$s/$m/outputs/MM* $dst1/$exp/$s/$m/outputs/
     rsync -acrv --remove-sent-files ${plt}:${src}/$exp/$s/$m/restarts/REST?_* $dst1/$exp/$s/$m/restarts/
#     rsync -acrv --remove-sent-files ${plt}:${src}/$exp/$s/$m/outputs/ICM* $dst2/$exp/$s/$m/outputs/
  else
     rsync -av ${plt}:${src}/$exp/$s/$m/logfiles* $dst1/$exp/$s/$m/
     rsync -av ${plt}:${src}/$exp/$s/$m/outputs/MM* $dst1/$exp/$s/$m/outputs/
     rsync -av ${plt}:${src}/$exp/$s/$m/restarts/REST?_* $dst1/$exp/$s/$m/restarts/
#     rsync -av ${plt}:${src}/$exp/$s/$m/outputs/ICM* $dst2/$exp/$s/$m/outputs/
  fi
  set -e
 done
done

date
